## nanobind 1.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.27)
project(nanobind LANGUAGES NONE)

# ---------------------------------------------------------------------------
# Only build tests by default if this is the top-level CMake project
# ---------------------------------------------------------------------------

if (CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  set(NB_MASTER_PROJECT ON)
else()
  set(NB_MASTER_PROJECT OFF)
endif()

option(NB_CREATE_INSTALL_RULES "Create installation rules" ${NB_MASTER_PROJECT})
option(NB_USE_SUBMODULE_DEPS   "Use the nanobind dependencies shipped as a git submodule of this repository" ON)

option(NB_TEST              "Compile nanobind tests?" ${NB_MASTER_PROJECT})
option(NB_TEST_STABLE_ABI   "Test the stable ABI interface?" OFF)
option(NB_TEST_SHARED_BUILD "Build a shared nanobind library for the test suite?" OFF)

# ---------------------------------------------------------------------------
# Do a release build if nothing was specified
# ---------------------------------------------------------------------------

if (NB_MASTER_PROJECT AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "nanobind: setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# ---------------------------------------------------------------------------
# Check whether all dependencies are present
# ---------------------------------------------------------------------------

if (NB_USE_SUBMODULE_DEPS AND NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/ext/robin_map/include")
  message(FATAL_ERROR "The nanobind dependencies are missing! "
    "You probably did not clone the project with --recursive. It is possible to recover "
    "by invoking\n$ git submodule update --init --recursive")
endif()

# ---------------------------------------------------------------------------
# Installation rules
# ---------------------------------------------------------------------------

if(NB_CREATE_INSTALL_RULES AND NOT CMAKE_SKIP_INSTALL_RULES)
  # Silence warning in GNUInstallDirs due to no enabled languages
  set(CMAKE_INSTALL_LIBDIR "")
  include(GNUInstallDirs)
  set(NB_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/nanobind"
    CACHE PATH "Installation path for read-only architecture-independent nanobind data files")

  # Normally these would be configurable by the user, but we can't allow that
  # because the lookup paths are hard-coded in 'cmake/nanobind-config.cmake'
  set(NB_INSTALL_INC_DIR "${NB_INSTALL_DATADIR}/include")
  set(NB_INSTALL_SRC_DIR "${NB_INSTALL_DATADIR}/src")
  set(NB_INSTALL_EXT_DIR "${NB_INSTALL_DATADIR}/ext")
  set(NB_INSTALL_MODULE_DIR "${NB_INSTALL_DATADIR}")
  set(NB_INSTALL_CMAKE_DIR "${NB_INSTALL_DATADIR}/cmake")

  install(
    DIRECTORY include/
    DESTINATION "${NB_INSTALL_INC_DIR}"
  )

  install(
    DIRECTORY src/
    DESTINATION "${NB_INSTALL_SRC_DIR}"
    PATTERN "*.py" EXCLUDE
  )

  install(
    DIRECTORY src/
    DESTINATION "${NB_INSTALL_MODULE_DIR}"
    FILES_MATCHING PATTERN "*\.py"
  )

  if(NB_USE_SUBMODULE_DEPS)
    install(
      DIRECTORY ext/robin_map/include/
      DESTINATION "${NB_INSTALL_EXT_DIR}/robin_map/include"
    )
    install(
      FILES ext/robin_map/CMakeLists.txt
      DESTINATION "${NB_INSTALL_EXT_DIR}/robin_map"
    )
  endif()

  install(
    DIRECTORY cmake/
    DESTINATION "${NB_INSTALL_CMAKE_DIR}"
  )
endif()

# Return early to skip finding needless dependencies if the user only wishes to
# install nanobind
if (NB_MASTER_PROJECT AND NOT NB_TEST)
  return()
else()
  enable_language(CXX)
endif()

# ---------------------------------------------------------------------------
# Compile with a few more compiler warnings turned on
# ---------------------------------------------------------------------------

if (MSVC)
  if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    add_compile_options(/W4)
  endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
  add_compile_options(-Wall -Wextra -Wno-unused-local-typedefs)
endif()

# ---------------------------------------------------------------------------
# Find the Python interpreter and development libraries
# ---------------------------------------------------------------------------

if (NOT TARGET Python::Module OR NOT TARGET Python::Interpreter)
  set(Python_FIND_FRAMEWORK LAST) # Prefer Brew/Conda to Apple framework python

  if (CMAKE_VERSION VERSION_LESS 3.18)
    set(NB_PYTHON_DEV_MODULE Development)
  else()
    set(NB_PYTHON_DEV_MODULE Development.Module)
  endif()

  find_package(Python 3.8
    REQUIRED COMPONENTS Interpreter ${NB_PYTHON_DEV_MODULE}
    OPTIONAL_COMPONENTS Development.SABIModule)
endif()

# ---------------------------------------------------------------------------
# Include nanobind cmake functionality
# ---------------------------------------------------------------------------

find_package(nanobind
  PATHS ${CMAKE_CURRENT_SOURCE_DIR}/cmake
  NO_DEFAULT_PATH)

if (NB_TEST)
  add_subdirectory(tests)
endif()

=== docs/requirements.txt ===
furo==2022.12.7
sphinx==6.1.3
sphinx-copybutton==0.5.1
sphinxcontrib-moderncmakedomain==3.25.0
sphinxcontrib-svg2pdfconverter==1.2.2

=== tests/CMakeLists.txt ===
# If leaks are found, abort() during interpreter shutdown to catch this in the CI
add_definitions(-DNB_ABORT_ON_LEAK)

if (NB_TEST_STABLE_ABI)
  set(NB_EXTRA_ARGS ${NB_EXTRA_ARGS} STABLE_ABI)
endif()

if (NB_TEST_SHARED_BUILD)
  set(NB_EXTRA_ARGS ${NB_EXTRA_ARGS} NB_SHARED)
endif()

# Enable extra warning flags
if (MSVC)
  add_compile_options(/W4)
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  add_compile_options(-Wall -Wextra -Wno-unused-local-typedefs)
endif()

if (UNIX AND (CMAKE_SIZEOF_VOID_P EQUAL 4) AND (CMAKE_SYSTEM_PROCESSOR STREQUAL i686))
  # Don't use the legacy 387 math coprocessor in 32 bit builds, this causes tests to fail
  add_compile_options(-mfpmath=sse -msse2)
endif()

nanobind_add_module(test_functions_ext test_functions.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_classes_ext test_classes.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_holders_ext test_holders.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_stl_ext test_stl.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_bind_map_ext test_stl_bind_map.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_bind_vector_ext test_stl_bind_vector.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_chrono_ext test_chrono.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_enum_ext test_enum.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_eval_ext test_eval.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_ndarray_ext test_ndarray.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_intrusive_ext test_intrusive.cpp test_intrusive_impl.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_exception_ext test_exception.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_make_iterator_ext test_make_iterator.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_issue_ext test_issue.cpp ${NB_EXTRA_ARGS})

find_package (Eigen3 3.3.1 NO_MODULE)
if (TARGET Eigen3::Eigen)
  nanobind_add_module(test_eigen_ext test_eigen.cpp ${NB_EXTRA_ARGS})
  target_link_libraries(test_eigen_ext PRIVATE Eigen3::Eigen)
endif()

add_library(
  inter_module
  SHARED
  inter_module.h
  inter_module.cpp
)

target_compile_definitions(inter_module PRIVATE -DSHARED_BUILD)
target_compile_features(inter_module PRIVATE cxx_std_17)
target_include_directories(inter_module PRIVATE ${NB_DIR}/include)

nanobind_add_module(test_inter_module_1_ext NB_DOMAIN mydomain test_inter_module_1.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_inter_module_2_ext NB_DOMAIN mydomain test_inter_module_2.cpp ${NB_EXTRA_ARGS})
target_link_libraries(test_inter_module_1_ext PRIVATE inter_module)
target_link_libraries(test_inter_module_2_ext PRIVATE inter_module)

set(TEST_FILES
  common.py
  test_classes.py
  test_eigen.py
  test_enum.py
  test_eval.py
  test_exception.py
  test_functions.py
  test_holders.py
  test_inter_module.py
  test_intrusive.py
  test_make_iterator.py
  test_stl.py
  test_stl_bind_map.py
  test_stl_bind_vector.py
  test_chrono.py
  test_ndarray.py
)

if (NOT (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR) OR MSVC)
  if (MSVC)
    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
  else()
    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
  endif()

  foreach(TEST_FILE IN LISTS TEST_FILES)
    set(IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE})
    set(OUT_FILE ${OUT_DIR}/${TEST_FILE})
    set(TEST_FILES_OUT ${TEST_FILES_OUT} ${OUT_FILE})
    add_custom_command(
      DEPENDS ${IN_FILE} TARGET OUTPUT ${OUT_FILE}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${IN_FILE} ${OUT_DIR})
  endforeach()

  add_custom_target(copy-tests ALL DEPENDS ${TEST_FILES_OUT})
endif()

=== debian/changelog ===
nanobind (1.9.2-1) unstable; urgency=medium

  * New upstream version 1.9.2

 -- Timo Röhling <roehling@debian.org>  Sun, 25 Feb 2024 22:26:36 +0100

nanobind (1.9.0-1) unstable; urgency=medium

  * New upstream version 1.9.0
  * Drop backported upstream patch

 -- Timo Röhling <roehling@debian.org>  Tue, 20 Feb 2024 20:44:04 +0100

nanobind (1.8.0-4) unstable; urgency=medium

  * Remove optional test dependency on python3-torch (Closes: #1061615)

 -- Timo Röhling <roehling@debian.org>  Tue, 30 Jan 2024 10:19:10 +0100

nanobind (1.8.0-3) unstable; urgency=medium

  * Restrict architectures of python3-torch for autopkgtest

 -- Timo Röhling <roehling@debian.org>  Thu, 23 Nov 2023 12:01:44 +0100

nanobind (1.8.0-2) unstable; urgency=medium

  * Depend on pytorch on supported architectures only

 -- Timo Röhling <roehling@debian.org>  Mon, 20 Nov 2023 12:50:30 +0100

nanobind (1.8.0-1) unstable; urgency=medium

  * Initial release (Closes: #1055829)

 -- Timo Röhling <roehling@debian.org>  Sat, 18 Nov 2023 22:54:32 +0100

=== debian/control ===
Source: nanobind
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-python,
 libeigen3-dev <!nocheck>,
 libpython3-all-dev,
 python3-all-dev:any,
 python3-numpy <!nocheck>,
 python3-pytest <!nocheck>,
 python3-scipy <!nocheck>,
 robin-map-dev <!nocheck>,
Homepage: https://github.com/wjakob/nanobind
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/python-team/packages/nanobind.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/nanobind
Description: Tiny and efficient C++/Python bindings
 nanobind is a small binding library that exposes C++ types in Python and vice
 versa. It is reminiscent of Boost.Python and pybind11 and uses near-identical
 syntax. In contrast to these existing tools, nanobind is more efficient:
 bindings compile in a shorter amount of time, produce smaller binaries, and
 have better runtime performance.

Package: nanobind-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libeigen3-dev,
 robin-map-dev,
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package installs the development files.

=== debian/rules ===
#!/usr/bin/make -f

NB_TEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

export PYBUILD_SYSTEM = cmake
export PYBUILD_CONFIGURE_ARGS = -DNB_USE_SUBMODULE_DEPS=OFF -DNB_TEST=$(NB_TEST)
export PYBUILD_TEST_CUSTOM = 1
export PYBUILD_TEST_ARGS = cd {build_dir} && PYTHONPATH={build_dir}/tests {interpreter} -m pytest

%:
	dh $@ --buildsystem=pybuild

=== debian/tests/control ===
Tests: run-test-suite
Depends:
 cmake,
 g++ | c++-compiler,
 libeigen3-dev,
 libpython3-dev,
 nanobind-dev,
 python3-dev,
 python3-numpy,
 python3-pytest,
 python3-scipy,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1% \
 https://api.github.com/repos/wjakob/nanobind/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@

## nanobind 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,10 @@
 option(NB_TEST              "Compile nanobind tests?" ${NB_MASTER_PROJECT})
 option(NB_TEST_STABLE_ABI   "Test the stable ABI interface?" OFF)
 option(NB_TEST_SHARED_BUILD "Build a shared nanobind library for the test suite?" OFF)
+
+if (NOT MSVC)
+  option(NB_TEST_SANITZE    "Build tests with address and undefined behavior sanitizers?" OFF)
+endif()
 
 # ---------------------------------------------------------------------------
 # Do a release build if nothing was specified

=== debian/changelog ===
nanobind (2.0.0-3) unstable; urgency=medium

  * Tighten versioned dependencies
  * Create .dist-info instead of .egg-info

 -- Timo Röhling <roehling@debian.org>  Tue, 11 Jun 2024 16:17:58 +0200

nanobind (2.0.0-2) unstable; urgency=medium

  * Add Breaks to help fenics-basix and fenics-dolfinx migrate

 -- Timo Röhling <roehling@debian.org>  Fri, 07 Jun 2024 09:45:04 +0200

nanobind (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0
  * Update patch (no function change)
  * Bump Standards-Version to 4.7.0
  * Fix test invocation
  * Fix ndarray stub reference
  * Install stubgen.py in /usr/share/nanobind as well

 -- Timo Röhling <roehling@debian.org>  Mon, 27 May 2024 16:46:48 +0200

nanobind (1.9.2-3) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <roehling@debian.org>  Sat, 06 Apr 2024 22:27:58 +0200

nanobind (1.9.2-2) unstable; urgency=medium

  * Ship public nanobind module (Closes: #1067085)

 -- Timo Röhling <roehling@debian.org>  Sat, 06 Apr 2024 01:33:25 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

NB_TEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

export PYBUILD_SYSTEM = cmake
export PYBUILD_CONFIGURE_ARGS = -DNB_USE_SUBMODULE_DEPS=OFF -DNB_TEST=$(NB_TEST)
export PYBUILD_TEST_ARGS = || true; {interpreter} -m pytest --ignore=tests {build_dir}/tests

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_install:
	python3 debian/helpers/dist_info.py \
		--name=nanobind \
		--version=$(DEB_VERSION_UPSTREAM) \
		--add-metadata="Author: Wenzel Jakob" \
		--add-metadata="Author-email: wenzel.jakob@epfl.ch" \
		--add-metadata="Home-page: https://github.com/wjakob/nanobind" \
		--add-metadata="License: BSD-3-Clause" \
		--add-metadata="Summary: tiny and efficient C++/Python bindings" \
		--output-dir=debian/tmp/usr/lib/python3/dist-packages

## nanobind 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,18 @@
 cmake_minimum_required(VERSION 3.15...3.27)
-project(nanobind LANGUAGES NONE)
+
+# ---------------------------------------------------------------------------
+# Read the project version from nanobind.h
+# ---------------------------------------------------------------------------
+
+file(STRINGS "include/nanobind/nanobind.h" _nanobind_h_version REGEX "^#define NB_VERSION_.*$")
+string(REGEX MATCH "#define NB_VERSION_MAJOR ([0-9]+)" _ "${_nanobind_h_version}")
+set(_major ${CMAKE_MATCH_1})
+string(REGEX MATCH "#define NB_VERSION_MINOR ([0-9]+)" _ "${_nanobind_h_version}")
+set(_minor ${CMAKE_MATCH_1})
+string(REGEX MATCH "#define NB_VERSION_PATCH ([0-9]+)" _ "${_nanobind_h_version}")
+set(_patch ${CMAKE_MATCH_1})
+
+project(nanobind LANGUAGES NONE VERSION "${_major}.${_minor}.${_patch}")
 
 # ---------------------------------------------------------------------------
 # Only build tests by default if this is the top-level CMake project
@@ -46,12 +59,11 @@
 # ---------------------------------------------------------------------------
 # Installation rules
 # ---------------------------------------------------------------------------
-
 if(NB_CREATE_INSTALL_RULES AND NOT CMAKE_SKIP_INSTALL_RULES)
   # Silence warning in GNUInstallDirs due to no enabled languages
   set(CMAKE_INSTALL_LIBDIR "")
   include(GNUInstallDirs)
-  set(NB_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/nanobind"
+  set(NB_INSTALL_DATADIR "nanobind"
     CACHE PATH "Installation path for read-only architecture-independent nanobind data files")
 
   # Normally these would be configurable by the user, but we can't allow that
@@ -81,17 +93,27 @@
 
   if(NB_USE_SUBMODULE_DEPS)
     install(
-      DIRECTORY ext/robin_map/include/
-      DESTINATION "${NB_INSTALL_EXT_DIR}/robin_map/include"
-    )
-    install(
-      FILES ext/robin_map/CMakeLists.txt
-      DESTINATION "${NB_INSTALL_EXT_DIR}/robin_map"
+      FILES ext/robin_map/include/tsl/robin_map.h
+            ext/robin_map/include/tsl/robin_hash.h
+            ext/robin_map/include/tsl/robin_growth_policy.h
+      DESTINATION "${NB_INSTALL_EXT_DIR}/robin_map/include/tsl"
     )
   endif()
 
   install(
-    DIRECTORY cmake/
+    FILES cmake/nanobind-config.cmake
+          cmake/darwin-ld-cpython.sym
+          cmake/darwin-ld-pypy.sym
+    DESTINATION "${NB_INSTALL_CMAKE_DIR}"
+  )
+
+  include(CMakePackageConfigHelpers)
+  write_basic_package_version_file(
+    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+    COMPATIBILITY SameMajorVersion
+  )
+  install(
+    FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
     DESTINATION "${NB_INSTALL_CMAKE_DIR}"
   )
 endif()
@@ -139,10 +161,7 @@
 # ---------------------------------------------------------------------------
 # Include nanobind cmake functionality
 # ---------------------------------------------------------------------------
-
-find_package(nanobind
-  PATHS ${CMAKE_CURRENT_SOURCE_DIR}/cmake
-  NO_DEFAULT_PATH)
+include(cmake/nanobind-config.cmake)
 
 if (NB_TEST)
   add_subdirectory(tests)

=== debian/changelog ===
nanobind (2.1.0-1) unstable; urgency=medium

  * New upstream version 2.1.0
  * Update patches
    - Drop 0002-Fix-ndarray-stub-reference.patch (obsolete)
  * Override NB_INSTALL_DATADIR to restore old behavior
  * Skip broken stub reference test

 -- Timo Röhling <roehling@debian.org>  Sat, 31 Aug 2024 00:42:36 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Timo Röhling <roehling@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-python3,
  cmake,
  dh-python,
  libeigen3-dev <!nocheck>,
@@ -14,9 +15,10 @@
  python3-numpy <!nocheck>,
  python3-pytest <!nocheck>,
  python3-scipy <!nocheck>,
+ python3-setuptools,
  robin-map-dev <!nocheck>,
 Homepage: https://github.com/wjakob/nanobind
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/nanobind.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/nanobind
@@ -39,3 +41,14 @@
  .
  This package installs the development files.
 
+Package: python3-nanobind
+Architecture: all
+Depends:
+ ${misc:Depends},
+ ${python3:Depends},
+ nanobind-dev (= ${binary:Version}),
+Description: ${source:Synopsis} (Python 3 module)
+ ${source:Extended-Description}
+ .
+ This package installs the Python 3 module.
+

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,11 @@
 NB_TEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 export PYBUILD_SYSTEM = cmake
-export PYBUILD_CONFIGURE_ARGS = -DNB_USE_SUBMODULE_DEPS=OFF -DNB_TEST=$(NB_TEST)
-export PYBUILD_TEST_ARGS = || true; {interpreter} -m pytest --ignore=tests {build_dir}/tests
+export PYBUILD_CONFIGURE_ARGS = \
+	-DNB_USE_SUBMODULE_DEPS=OFF \
+	-DNB_TEST=$(NB_TEST) \
+	-DNB_INSTALL_DATADIR=/usr/share/nanobind
+export PYBUILD_TEST_ARGS = || true; {interpreter} -m pytest --ignore=tests {build_dir}/tests -k "not test01_check_stub_refs"
 
 %:
 	dh $@ --buildsystem=pybuild

## nanobind 2.2.0

=== debian/changelog ===
nanobind (2.2.0-2) unstable; urgency=medium

  * Expose ABI version for reverse dependenies (Closes: #1085019)

 -- Timo Röhling <roehling@debian.org>  Fri, 22 Nov 2024 15:10:36 +0100

nanobind (2.2.0-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 2.2.0
  * Wrap and sort Debian package files
  * Refresh patch (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 06 Oct 2024 23:27:38 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders:
- Timo Röhling <roehling@debian.org>
+ Timo Röhling <roehling@debian.org>,
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
+ dh-python,
  dh-sequence-python3,
- cmake,
- dh-python,
  libeigen3-dev <!nocheck>,
  libpython3-all-dev,
  python3-all-dev:any,
@@ -33,9 +33,9 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- ${misc:Depends},
  libeigen3-dev,
  robin-map-dev,
+ ${misc:Depends},
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
  .
@@ -44,11 +44,12 @@
 Package: python3-nanobind
 Architecture: all
 Depends:
+ nanobind-dev (= ${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
- nanobind-dev (= ${binary:Version}),
+Provides:
+ ${nanobind:Provides},
 Description: ${source:Synopsis} (Python 3 module)
  ${source:Extended-Description}
  .
  This package installs the Python 3 module.
-

## nanobind 2.4.0

=== debian/changelog ===
nanobind (2.4.0-1) unstable; urgency=medium

  * New upstream version 2.4.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Dec 2024 22:14:54 +0100

## nanobind 2.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,12 +27,16 @@
 option(NB_CREATE_INSTALL_RULES "Create installation rules" ${NB_MASTER_PROJECT})
 option(NB_USE_SUBMODULE_DEPS   "Use the nanobind dependencies shipped as a git submodule of this repository" ON)
 
-option(NB_TEST              "Compile nanobind tests?" ${NB_MASTER_PROJECT})
-option(NB_TEST_STABLE_ABI   "Test the stable ABI interface?" OFF)
-option(NB_TEST_SHARED_BUILD "Build a shared nanobind library for the test suite?" OFF)
+option(NB_TEST               "Compile nanobind tests?" ${NB_MASTER_PROJECT})
+option(NB_TEST_STABLE_ABI    "Test the stable ABI interface?" OFF)
+option(NB_TEST_SHARED_BUILD  "Build a shared nanobind library for the test suite?" OFF)
+option(NB_TEST_CUDA          "Force the use of the CUDA/NVCC compiler for testing purposes" OFF)
+option(NB_TEST_FREE_THREADED "Build free-threaded extensions for the test suite?" ON)
 
 if (NOT MSVC)
-  option(NB_TEST_SANITZE    "Build tests with address and undefined behavior sanitizers?" OFF)
+  option(NB_TEST_SANITIZERS_ASAN  "Build tests with the address sanitizer?" OFF)
+  option(NB_TEST_SANITIZERS_UBSAN "Build tests with the address undefined behavior sanitizer?" OFF)
+  option(NB_TEST_SANITIZERS_TSAN  "Build tests with the thread sanitizer?" OFF)
 endif()
 
 # ---------------------------------------------------------------------------
@@ -127,20 +131,6 @@
 endif()
 
 # ---------------------------------------------------------------------------
-# Compile with a few more compiler warnings turned on
-# ---------------------------------------------------------------------------
-
-if (MSVC)
-  if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
-    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
-  else()
-    add_compile_options(/W4)
-  endif()
-elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
-  add_compile_options(-Wall -Wextra -Wno-unused-local-typedefs)
-endif()
-
-# ---------------------------------------------------------------------------
 # Find the Python interpreter and development libraries
 # ---------------------------------------------------------------------------

=== tests/CMakeLists.txt ===
# If leaks are found, abort() during interpreter shutdown to catch this in the CI
add_definitions(-DNB_ABORT_ON_LEAK)

if (NB_TEST_STABLE_ABI)
  set(NB_EXTRA_ARGS ${NB_EXTRA_ARGS} STABLE_ABI)
endif()

if (NB_TEST_FREE_THREADED)
  set(NB_EXTRA_ARGS ${NB_EXTRA_ARGS} FREE_THREADED)
endif()

if (NB_TEST_SHARED_BUILD)
  set(NB_EXTRA_ARGS ${NB_EXTRA_ARGS} NB_SHARED)
endif()

# ---------------------------------------------------------------------------
# Compile with a few more compiler warnings turned on
# ---------------------------------------------------------------------------

if (MSVC)
  if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  elseif (NOT NB_TEST_CUDA)
    add_compile_options(/W4)
  endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
  add_compile_options(-Wall -Wextra -Wno-unused-local-typedefs)
endif()

if (UNIX AND (CMAKE_SIZEOF_VOID_P EQUAL 4) AND (CMAKE_SYSTEM_PROCESSOR STREQUAL i686))
  # Don't use the legacy 387 math coprocessor in 32 bit builds, this causes tests to fail
  add_compile_options(-mfpmath=sse -msse2)
endif()

# Enforce the use of the CUDA NVCC compiler if requested
if (NB_TEST_CUDA)
  enable_language(CUDA)
  set(CMAKE_CUDA_STANDARD 17)
  set(CMAKE_CUDA_STANDARD_REQUIRED ON)
endif()

set(NB_TEST_SANITIZER "")

if (NB_TEST_SANITIZERS_ASAN)
  list(APPEND NB_TEST_SANITIZERS address)
endif()

if (NB_TEST_SANITIZERS_UBSAN)
  list(APPEND NB_TEST_SANITIZERS undefined)
endif()

if (NB_TEST_SANITIZERS_TSAN)
  list(APPEND NB_TEST_SANITIZERS thread)
endif()


if (NB_TEST_SANITIZERS)
  string(REPLACE ";" "," NB_TEST_SANITIZERS "${NB_TEST_SANITIZERS}")
  add_compile_options(-fsanitize=${NB_TEST_SANITIZERS})
  add_link_options(-fsanitize=${NB_TEST_SANITIZERS})
endif()

set(TEST_NAMES
  functions
  callbacks
  classes
  holders
  stl
  stl_bind_map
  stl_bind_vector
  chrono
  enum
  eval
  ndarray
  exception
  make_iterator
  typing
  issue
  intrusive
  thread
)

foreach (NAME ${TEST_NAMES})
  nanobind_add_module(test_${NAME}_ext test_${NAME}.cpp ${NB_EXTRA_ARGS})

  if (NB_TEST_CUDA)
    set_property(SOURCE test_${NAME}.cpp PROPERTY LANGUAGE CUDA)
  endif()
endforeach()

target_sources(test_intrusive_ext PRIVATE test_intrusive_impl.cpp)

foreach (NAME functions classes ndarray stl enum typing make_iterator)
  if (NAME STREQUAL typing)
    set(EXTRA
      MARKER_FILE py.typed
      PATTERN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/pattern_file.nb"
    )
  else()
    set(EXTRA "")
  endif()

  if (CMAKE_CONFIGURATION_TYPES)
    # On multi-config generators like Visual Studio, put stubs in the 'Debug' / 'Release' /.. folders
    set(PYI_PREFIX $<CONFIG>/)
  endif()

  nanobind_add_stub(
    ${NAME}_ext_stub
    MODULE test_${NAME}_ext
    OUTPUT ${PYI_PREFIX}test_${NAME}_ext.pyi
    PYTHON_PATH $<TARGET_FILE_DIR:test_${NAME}_ext>
    DEPENDS test_${NAME}_ext
    ${EXTRA})
endforeach()

find_package (Eigen3 3.3.1 NO_MODULE)
if (TARGET Eigen3::Eigen)
  nanobind_add_module(test_eigen_ext test_eigen.cpp ${NB_EXTRA_ARGS})
  target_link_libraries(test_eigen_ext PRIVATE Eigen3::Eigen)
endif()

add_library(
  inter_module
  SHARED
  inter_module.h
  inter_module.cpp
)

target_compile_definitions(inter_module PRIVATE -DSHARED_BUILD)
target_compile_features(inter_module PRIVATE cxx_std_17)
target_include_directories(inter_module PRIVATE ${NB_DIR}/include)

nanobind_add_module(test_inter_module_1_ext NB_DOMAIN mydomain test_inter_module_1.cpp ${NB_EXTRA_ARGS})
nanobind_add_module(test_inter_module_2_ext NB_DOMAIN mydomain test_inter_module_2.cpp ${NB_EXTRA_ARGS})
target_link_libraries(test_inter_module_1_ext PRIVATE inter_module)
target_link_libraries(test_inter_module_2_ext PRIVATE inter_module)

set(TEST_FILES
  common.py
  test_callbacks.py
  test_classes.py
  test_eigen.py
  test_enum.py
  test_eval.py
  test_exception.py
  test_functions.py
  test_holders.py
  test_inter_module.py
  test_intrusive.py
  test_make_iterator.py
  test_stl.py
  test_stl_bind_map.py
  test_stl_bind_vector.py
  test_chrono.py
  test_ndarray.py
  test_stubs.py
  test_typing.py
  test_thread.py

  # Stub reference files
  test_classes_ext.pyi.ref
  test_functions_ext.pyi.ref
  test_make_iterator_ext.pyi.ref
  test_ndarray_ext.pyi.ref
  test_stl_ext.pyi.ref
  test_enum_ext.pyi.ref
  test_typing_ext.pyi.ref
  py_stub_test.py
  py_stub_test.pyi.ref
)

set (PY_STUB_TEST py_stub_test.py)
if (NOT (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR) OR MSVC)
  if (CMAKE_CONFIGURATION_TYPES)
    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
  else()
    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
  endif()

  foreach(TEST_FILE IN LISTS TEST_FILES)
    set(IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE})
    set(OUT_FILE ${OUT_DIR}/${TEST_FILE})
    set(TEST_FILES_OUT ${TEST_FILES_OUT} ${OUT_FILE})
    add_custom_command(
      DEPENDS ${IN_FILE} OUTPUT ${OUT_FILE}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${IN_FILE} ${OUT_DIR})
  endforeach()

  add_custom_target(copy-tests ALL DEPENDS ${TEST_FILES_OUT})
  set(PY_STUB_TEST ${OUT_DIR}/py_stub_test.py)
endif()

nanobind_add_stub(
  py_stub
  MODULE py_stub_test
  OUTPUT ${PYI_PREFIX}py_stub_test.pyi
  PYTHON_PATH $<TARGET_FILE_DIR:test_stl_ext>
  DEPENDS ${PY_STUB_TEST}
)

=== debian/changelog ===
nanobind (2.5.0-1) unstable; urgency=medium

  * New upstream version 2.5.0
  * Refresh patches (no functional changes)
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Wed, 05 Feb 2025 10:56:31 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders:
  Timo Röhling <roehling@debian.org>,
 Build-Depends:
- cmake,
  debhelper-compat (= 13),
  dh-python,
  dh-sequence-python3,
+ cmake,
  libeigen3-dev <!nocheck>,
  libpython3-all-dev,
  python3-all-dev:any,

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1%,\
 searchmode=plain \
 https://api.github.com/repos/wjakob/nanobind/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@

## nanobind 2.7.0

=== debian/changelog ===
nanobind (2.7.0-1) experimental; urgency=medium

  * New upstream version 2.7.0
  * Refresh patches (no functional changes)
  * ABI version 16
  * Rework ABI version detection
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Sat, 12 Jul 2025 17:56:59 +0200

## nanobind 2.8.0

=== debian/changelog ===
nanobind (2.8.0-1) experimental; urgency=medium

  * Extract ABI version more robustly
  * Fix minimum version to accurately reflect last ABI version bump
  * New upstream version 2.8.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Wed, 23 Jul 2025 21:21:08 +0200

## nanobind 2.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -93,6 +93,7 @@
     DIRECTORY src/
     DESTINATION "${NB_INSTALL_MODULE_DIR}"
     FILES_MATCHING PATTERN "*\.py"
+    PATTERN "version.py" EXCLUDE
   )
 
   if(NB_USE_SUBMODULE_DEPS)
@@ -106,6 +107,7 @@
 
   install(
     FILES cmake/nanobind-config.cmake
+          cmake/darwin-python-path.py
           cmake/darwin-ld-cpython.sym
           cmake/darwin-ld-pypy.sym
     DESTINATION "${NB_INSTALL_CMAKE_DIR}"

=== docs/requirements.txt ===
furo
sphinx==6.1.3
sphinx-copybutton==0.5.1
sphinxcontrib-moderncmakedomain==3.25.0
sphinxcontrib-svg2pdfconverter==1.2.2

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -61,6 +61,7 @@
 endif()
 
 set(TEST_NAMES
+  accessor
   functions
   callbacks
   classes
@@ -72,6 +73,8 @@
   enum
   eval
   ndarray
+  jax
+  tensorflow
   exception
   make_iterator
   typing
@@ -90,14 +93,22 @@
 
 target_sources(test_intrusive_ext PRIVATE test_intrusive_impl.cpp)
 
-foreach (NAME functions classes ndarray stl enum typing make_iterator)
+if (CMAKE_CONFIGURATION_TYPES)
+  set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
+else()
+  set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
+endif()
+
+foreach (NAME functions classes ndarray jax tensorflow stl enum typing make_iterator)
   if (NAME STREQUAL typing)
     set(EXTRA
       MARKER_FILE py.typed
       PATTERN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/pattern_file.nb"
     )
+    set(EXTRA_DEPENDS "${OUT_DIR}/py_stub_test.py")
   else()
     set(EXTRA "")
+    set(EXTRA_DEPENDS "")
   endif()
 
   if (CMAKE_CONFIGURATION_TYPES)
@@ -110,7 +121,7 @@
     MODULE test_${NAME}_ext
     OUTPUT ${PYI_PREFIX}test_${NAME}_ext.pyi
     PYTHON_PATH $<TARGET_FILE_DIR:test_${NAME}_ext>
-    DEPENDS test_${NAME}_ext
+    DEPENDS test_${NAME}_ext ${EXTRA_DEPENDS}
     ${EXTRA})
 endforeach()
 
@@ -138,6 +149,8 @@
 
 set(TEST_FILES
   common.py
+  conftest.py
+  test_accessor.py
   test_callbacks.py
   test_classes.py
   test_eigen.py
@@ -154,6 +167,8 @@
   test_stl_bind_vector.py
   test_chrono.py
   test_ndarray.py
+  test_jax.py
+  test_tensorflow.py
   test_stubs.py
   test_typing.py
   test_thread.py
@@ -163,28 +178,26 @@
   test_functions_ext.pyi.ref
   test_make_iterator_ext.pyi.ref
   test_ndarray_ext.pyi.ref
+  test_jax_ext.pyi.ref
+  test_tensorflow_ext.pyi.ref
   test_stl_ext.pyi.ref
   test_enum_ext.pyi.ref
   test_typing_ext.pyi.ref
   py_stub_test.py
   py_stub_test.pyi.ref
+  py_recursive_stub_test/__init__.pyi.ref
+  py_recursive_stub_test/bar.pyi.ref
 )
 
 set (PY_STUB_TEST py_stub_test.py)
 if (NOT (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR) OR MSVC)
-  if (CMAKE_CONFIGURATION_TYPES)
-    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
-  else()
-    set(OUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
-  endif()
-
   foreach(TEST_FILE IN LISTS TEST_FILES)
     set(IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE})
     set(OUT_FILE ${OUT_DIR}/${TEST_FILE})
     set(TEST_FILES_OUT ${TEST_FILES_OUT} ${OUT_FILE})
     add_custom_command(
       DEPENDS ${IN_FILE} OUTPUT ${OUT_FILE}
-      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${IN_FILE} ${OUT_DIR})
+      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${IN_FILE} ${OUT_FILE})
   endforeach()
 
   add_custom_target(copy-tests ALL DEPENDS ${TEST_FILES_OUT})
@@ -198,3 +211,15 @@
   PYTHON_PATH $<TARGET_FILE_DIR:test_stl_ext>
   DEPENDS ${PY_STUB_TEST}
 )
+
+nanobind_add_stub(
+  py_recursive_stub
+  RECURSIVE
+  MODULE py_recursive_stub_test
+  OUTPUT_PATH
+    ${PYI_PREFIX}py_recursive_stub_test
+  OUTPUT
+    ${PYI_PREFIX}py_recursive_stub_test/__init__.pyi
+    ${PYI_PREFIX}py_recursive_stub_test/bar.pyi
+  PYTHON_PATH ${CMAKE_CURRENT_SOURCE_DIR}
+)

=== debian/changelog ===
nanobind (2.9.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Fri, 26 Sep 2025 23:34:19 +0200

nanobind (2.9.2-1) experimental; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.9.2
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 07 Sep 2025 18:58:37 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  python3-setuptools,
  robin-map-dev <!nocheck>,
 Homepage: https://github.com/wjakob/nanobind
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/nanobind.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/nanobind

=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,6 @@
 		--add-metadata="Summary: tiny and efficient C++/Python bindings" \
 		--output-dir=debian/tmp/usr/lib/python3/dist-packages
 
+execute_before_dh_python3:
+	python3 debian/helpers/nanobind_provides.py
+

=== debian/tests/control ===
Tests:
 run-test-suite,
Depends:
 cmake,
 g++ | c++-compiler,
 libeigen3-dev,
 libpython3-dev,
 nanobind-dev,
 python3-dev,
 python3-numpy,
 python3-pytest,
 python3-scipy,
Restrictions:
 allow-stderr,

=== debian/watch ===
Version: 5

Template: Github
Owner: wjakob
Project: nanobind
Uversion-Mangle: auto
Dversion-Mangle: auto

## nanobind 2.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -145,7 +145,7 @@
     set(NB_PYTHON_DEV_MODULE Development.Module)
   endif()
 
-  find_package(Python 3.8
+  find_package(Python 3.9
     REQUIRED COMPONENTS Interpreter ${NB_PYTHON_DEV_MODULE}
     OPTIONAL_COMPONENTS Development.SABIModule)
 endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,8 @@
   elseif (NOT NB_TEST_CUDA)
     add_compile_options(/W4)
   endif()
-elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
-  add_compile_options(-Wall -Wextra -Wno-unused-local-typedefs)
+elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU|IntelLLVM")
+  add_compile_options(-Wall -Wextra)
 endif()
 
 if (UNIX AND (CMAKE_SIZEOF_VOID_P EQUAL 4) AND (CMAKE_SYSTEM_PROCESSOR STREQUAL i686))
@@ -104,6 +104,7 @@
     set(EXTRA
       MARKER_FILE py.typed
       PATTERN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/pattern_file.nb"
+      EXCLUDE_VALUES
     )
     set(EXTRA_DEPENDS "${OUT_DIR}/py_stub_test.py")
   else()

=== debian/changelog ===
nanobind (2.10.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Thu, 08 Jan 2026 20:36:48 +0100

nanobind (2.10.2-1) experimental; urgency=medium

  * New upstream version 2.10.2
  * Refresh patches (no functional changes)
  * New ABI version 17
  * Skip failing subinterpreter test (which only checks for an exception anyway)

 -- Timo Röhling <roehling@debian.org>  Sat, 13 Dec 2025 10:51:29 +0100

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	-DNB_USE_SUBMODULE_DEPS=OFF \
 	-DNB_TEST=$(NB_TEST) \
 	-DNB_INSTALL_DATADIR=/usr/share/nanobind
-export PYBUILD_TEST_ARGS = || true; {interpreter} -m pytest --ignore=tests {build_dir}/tests -k "not test01_check_stub_refs"
+export PYBUILD_TEST_ARGS = || true; {interpreter} -m pytest --ignore=tests {build_dir}/tests -k "not test01_check_stub_refs and not test04_subinterpreters"
 
 %:
 	dh $@ --buildsystem=pybuild

## nanobind 2.11.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -84,7 +84,11 @@
 )
 
 foreach (NAME ${TEST_NAMES})
-  nanobind_add_module(test_${NAME}_ext test_${NAME}.cpp ${NB_EXTRA_ARGS})
+  if (NAME STREQUAL classes)
+    nanobind_add_module(test_${NAME}_ext test_${NAME}.cpp test_${NAME}_extra.cpp ${NB_EXTRA_ARGS})
+  else()
+    nanobind_add_module(test_${NAME}_ext test_${NAME}.cpp ${NB_EXTRA_ARGS})
+  endif()
 
   if (NB_TEST_CUDA)
     set_property(SOURCE test_${NAME}.cpp PROPERTY LANGUAGE CUDA)
@@ -173,6 +177,7 @@
   test_stubs.py
   test_typing.py
   test_thread.py
+  test_specialization.py
 
   # Stub reference files
   test_classes_ext.pyi.ref

=== debian/changelog ===
nanobind (2.11.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Tue, 10 Feb 2026 22:59:37 +0100

nanobind (2.11.0-1) experimental; urgency=medium

  * New upstream version 2.11.0
  * Refresh patch (no functional changes)
  * New ABI version 18
  * Bump Standards-Version to 4.7.3

 -- Timo Röhling <roehling@debian.org>  Thu, 05 Feb 2026 18:30:20 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  python3-setuptools,
  robin-map-dev <!nocheck>,
 Homepage: https://github.com/wjakob/nanobind
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/python-team/packages/nanobind.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/nanobind

## nanobind 2.12.0

=== docs/requirements.txt ===
furo
sphinx==6.1.3
sphinx-copybutton==0.5.1
sphinxcontrib-moderncmakedomain==3.29.0
sphinxcontrib-svg2pdfconverter==1.2.2

=== debian/changelog ===
nanobind (2.12.0-1) experimental; urgency=medium

  * New upstream version 2.12.0
  * Update patches
    - Obsolete: 0002-Fix-regression-introduced-in-PR-1262.patch
    - Obsolete: 0003-Fix-missing-convert-flag-for-implicit-std-optional-n.patch
  * New ABI version 19

 -- Timo Röhling <roehling@debian.org>  Sat, 28 Feb 2026 15:11:51 +0100

nanobind (2.11.0-3) unstable; urgency=medium

  * robin-map-dev is required in 'nocheck' profile
  * Fix implicit conversion for std::optional<> types (Closes: #1127895)

 -- Timo Röhling <roehling@debian.org>  Tue, 17 Feb 2026 23:15:01 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  python3-pytest <!nocheck>,
  python3-scipy <!nocheck>,
  python3-setuptools,
- robin-map-dev <!nocheck>,
+ robin-map-dev,
 Homepage: https://github.com/wjakob/nanobind
 Standards-Version: 4.7.3
 Rules-Requires-Root: no
